import HelloWorld.*;           // The package containing our stubs.
import org.omg.CosNaming.*;  // CORBAClient will use the naming service.
import org.omg.CORBA.*;      // All CORBA applications need these classes.


public class HelloClient
{
  public static void main(String args[])
  {
    try{
      
      // Create and initialize the ORB
      ORB orb = ORB.init(args, null);
      
      // Get the root naming context
      org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
      NamingContextExt ncRef = NamingContextExtHelper.narrow(objRef);
      
   	  System.out.println("Hello object:");

      // Resolve the object reference in naming
      NameComponent path[] = ncRef.to_name("HelloWorld");
      Hello helloRef = HelloHelper.narrow(ncRef.resolve(path));
     
   	  System.out.println(helloRef.sayHello("Peter"));
   	  System.out.println(helloRef.myName());

   	  System.out.println("HelloToo object:");
      // Resolve the object reference in naming
      path = ncRef.to_name("HelloWorldToo");
      HelloToo helloRef2 = HelloTooHelper.narrow(ncRef.resolve(path));
     
   	  System.out.println(helloRef2.sayHello("Peter"));
   	  System.out.println(helloRef2.myName());
   	  System.out.println(helloRef2.sayHelloToo());

   	  System.out.println("HelloToo object via Hello reference:");
      // Resolve the object reference in naming
      path = ncRef.to_name("HelloWorldToo");
      Hello helloRef3 = HelloHelper.narrow(ncRef.resolve(path));
     
   	  System.out.println(helloRef3.sayHello("Peter"));
   	  System.out.println(helloRef3.myName());

    } catch(Exception e) {
        System.out.println("ERROR : " + e);
        e.printStackTrace(System.out);
      }  
  }
}


