// The package containing our stubs.
import HelloWorld.*;

// HelloServer will use the naming service.
import org.omg.CosNaming.*;

// The package containing special exceptions thrown by the name service.
import org.omg.CosNaming.NamingContextPackage.*;

// All CORBA applications need these classes.
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POA;

public class HelloServer 
{
  public static void main(String args[])
  {
    try{
    
      // Create and initialize the ORB
      ORB orb = ORB.init(args, null);
      
      POA rootpoa=POAHelper.narrow(orb.resolve_initial_references("RootPOA"));
      rootpoa.the_POAManager().activate();
      
      org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
      NamingContextExt ncRef = NamingContextExtHelper.narrow(objRef);
         
      // Create and bind the servant object
      HelloImpl helloImpl = new HelloImpl();
	  HelloPOATie helloTie = new HelloPOATie(helloImpl);
	  Hello href = helloTie._this(orb);
      ncRef.rebind(ncRef.to_name("HelloWorld"), href);

      // Create and bind the servant object
      HelloTooImpl helloImpl2 = new HelloTooImpl();
	  HelloTooPOATie helloTie2 = new HelloTooPOATie(helloImpl2);
	  HelloToo href2 = helloTie2._this(orb);
      ncRef.rebind(ncRef.to_name("HelloWorldToo"), href2);

	  System.out.println("HelloServer is running...");
	  
	  orb.run();
      
    } catch(Exception e) {
        System.err.println("ERROR: " + e);
        e.printStackTrace(System.out);
      }  
  }
}

